import React, { useState } from 'react';
import styled, { css } from 'styled-components';

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _taggedTemplateLiteralLoose(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  strings.raw = raw;
  return strings;
}

function _templateObject10() {
  var data = _taggedTemplateLiteralLoose(["\n    border: none;\n    background: transparent;\n    color: ", ";\n    font: 30px Arial;\n    text-shadow: 0 0 8px #bcdef7;\n    outline: none;\n    border-radius: 5px;\n    transition: all 0.4s;\n    cursor: pointer;\n    &:hover:not(:disabled) {\n      color: ", ";\n    }\n    &:disabled {\n      color: ", ";\n      cursor: default;\n    }\n    ", ";\n  "]);

  _templateObject10 = function _templateObject10() {
    return data;
  };

  return data;
}

function _templateObject9() {
  var data = _taggedTemplateLiteralLoose(["\n    margin: ", ";\n    padding: ", ";\n    width: ", ";\n    height: ", ";\n    display: ", ";\n    flex-direction: ", ";\n    justify-content: ", ";\n    align-items: ", ";\n    background: ", ";\n    border-radius: ", ";\n    animation: ", ";\n    animation-fill-mode: backwards;\n    transform-style: preserve-3d;\n    transition: all 5s;\n    transition-delay: 5s;\n    transition: all 0.2s;\n\n    @keyframes intro {\n      from {\n        opacity: 0;\n        transform: perspective(500px) translate3d(0, 0, -50px);\n      }\n\n      to {\n        opacity: 1;\n        transform: none;\n      }\n    }\n\n    @keyframes enterRight {\n      from {\n        opacity: 0;\n        transform: perspective(500px) translate3d(20%, 0, 0);\n      }\n\n      to {\n        opacity: 1;\n        transform: none;\n      }\n    }\n\n    @keyframes enterLeft {\n      from {\n        opacity: 0;\n        transform: perspective(500px) translate3d(-20%, 0, 0);\n      }\n\n      to {\n        opacity: 1;\n        transform: none;\n      }\n    }\n\n    @keyframes exitRight {\n      from {\n        opacity: 1;\n      }\n\n      to {\n        opacity: 0;\n        transform: perspective(500px) translate3d(100%, 0, -100px);\n      }\n    }\n\n    @keyframes exitLeft {\n      from {\n        opacity: 1;\n      }\n\n      to {\n        opacity: 0;\n        transform: perspective(500px) translate3d(-100%, 0, -100px);\n      }\n    }\n    ", ";\n  "]);

  _templateObject9 = function _templateObject9() {
    return data;
  };

  return data;
}

function _templateObject8() {
  var data = _taggedTemplateLiteralLoose(["\n    width: 100%;\n    height: 100%;\n    display: grid;\n    grid-template-columns: 0.5fr 4fr 0.5fr;\n  "]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = _taggedTemplateLiteralLoose(["\n      background: ", ";\n      border-color: ", ";\n      box-shadow: 0 0 4px 1px ", ";\n      &:hover {\n        background: ", ";\n        border-color: ", ";\n      }\n      ", ";\n    "]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = _taggedTemplateLiteralLoose(["\n            box-shadow: 0 0 4px 2px ", ";\n          "]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = _taggedTemplateLiteralLoose(["\n            cursor: default;\n          "]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = _taggedTemplateLiteralLoose(["\n    margin: 8px;\n    width: ", ";\n    height: 10px;\n    border-radius: 50%;\n    background: ", ";\n    border: 1px double ", ";\n    cursor: pointer;\n    transition: all 0.4s;\n    &:hover {\n      ", ";\n    }\n    ", ";\n  "]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteralLoose(["\n    margin: 80px 10px 50px 10px;\n    display: flex;\n    justify-content: center;\n    align-items: center;\n    ", ";\n  "]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteralLoose(["\n      flex-direction: column-reverse;\n    "]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteralLoose(["\n    margin: 0;\n    width: 100%;\n    display: flex;\n    flex-direction: column;\n    background: #f0f8ff;\n    overflow: hidden;\n    ", ";\n    ", ";\n  "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var DotsFormHolder = styled.div(function (_ref) {
  var topDots = _ref.topDots,
      styledComponents = _ref.styledComponents;
  return css(_templateObject(), !topDots && css(_templateObject2()), styledComponents);
});
var DotsHolder = styled.div(function (_ref2) {
  var styledComponents = _ref2.styledComponents;
  return css(_templateObject3(), styledComponents);
});
var DotForm = styled.div(function (_ref3) {
  var active = _ref3.active,
      activeStyledComponents = _ref3.activeStyledComponents,
      _ref3$dotsStyle = _ref3.dotsStyle,
      size = _ref3$dotsStyle.size,
      color = _ref3$dotsStyle.color,
      hoverShadowColor = _ref3$dotsStyle.hoverShadowColor,
      activeColor = _ref3$dotsStyle.activeColor,
      activeHoverColor = _ref3$dotsStyle.activeHoverColor,
      disabled = _ref3.disabled;
  return css(_templateObject4(), size || '10px', color || '#bcdef7', color || '#bcdef7', disabled ? css(_templateObject5()) : css(_templateObject6(), hoverShadowColor || '#4e85af'), active && css(_templateObject7(), activeColor || '#68beff', activeColor || '#68beff', activeColor || '#68beff', activeHoverColor || '#4e85af', activeHoverColor || '#4e85af', activeStyledComponents));
});
var TabsHolder = styled.div(function () {
  return css(_templateObject8());
});
var DotsFormTab = styled.form(function (_ref4) {
  var activeTab = _ref4.activeTab,
      width = _ref4.width,
      height = _ref4.height,
      padding = _ref4.padding,
      margin = _ref4.margin,
      display = _ref4.display,
      flexDirection = _ref4.flexDirection,
      justifyContent = _ref4.justifyContent,
      alignItems = _ref4.alignItems,
      background = _ref4.background,
      borderRadius = _ref4.borderRadius,
      styledComponents = _ref4.styledComponents,
      animation = _ref4.animation;
  return css(_templateObject9(), margin || 0, padding || '1%', width || '100%', height || '100%', activeTab ? display || 'flex' : 'none', flexDirection || 'column', justifyContent || 'center', alignItems || 'center', background || 'transparent', borderRadius || '20px', animation || 'intro 1s ease-out', styledComponents);
});
var ArrowButton = styled.button(function (_ref5) {
  var styledComponents = _ref5.styledComponents,
      _ref5$arrowsStyle = _ref5.arrowsStyle,
      color = _ref5$arrowsStyle.color,
      disabledColor = _ref5$arrowsStyle.disabledColor,
      hoverColor = _ref5$arrowsStyle.hoverColor;
  return css(_templateObject10(), color || '#68beff', hoverColor || ' #4e85af', disabledColor || ' #bcdef7', styledComponents);
});

var DotsForm = function DotsForm(_ref) {
  var children = _ref.children,
      _ref$topDots = _ref.topDots,
      topDots = _ref$topDots === void 0 ? false : _ref$topDots,
      _ref$removeArrows = _ref.removeArrows,
      removeArrows = _ref$removeArrows === void 0 ? false : _ref$removeArrows,
      _ref$removeDots = _ref.removeDots,
      removeDots = _ref$removeDots === void 0 ? false : _ref$removeDots,
      styledComponents = _ref.styledComponents,
      dotsStyledComponents = _ref.dotsStyledComponents,
      _ref$dotsStyle = _ref.dotsStyle,
      dotsStyle = _ref$dotsStyle === void 0 ? {
    size: null,
    color: null,
    hoverShadowColor: null,
    activeColor: null,
    activeHoverColor: null
  } : _ref$dotsStyle,
      dotsActiveStyledComponents = _ref.dotsActiveStyledComponents,
      arrowsStyledComponents = _ref.arrowsStyledComponents,
      _ref$arrowsStyle = _ref.arrowsStyle,
      arrowsStyle = _ref$arrowsStyle === void 0 ? {
    color: null,
    disabledColor: null,
    hoverColor: null
  } : _ref$arrowsStyle,
      _ref$tabsStyle = _ref.tabsStyle,
      tabsStyle = _ref$tabsStyle === void 0 ? {
    width: '98%',
    height: '98%',
    margin: 0,
    padding: '1%',
    display: 'flex',
    flexDirection: 'column',
    justifyContent: 'center',
    alignItems: 'center',
    background: 'transparent',
    borderRadius: '20px',
    styledComponents: ''
  } : _ref$tabsStyle;

  var _useState = useState(0),
      activeTab = _useState[0],
      setActiveTab = _useState[1];

  var _useState2 = useState('intro 1s ease-out'),
      animation = _useState2[0],
      setAnimation = _useState2[1];

  var onChangingTab = function onChangingTab(tabIndex) {
    var animate;
    if (tabIndex > activeTab) animate = 'enterRight 1s';
    if (tabIndex < activeTab) animate = 'enterLeft 1s';
    setAnimation(animate);
    setActiveTab(tabIndex);
  };

  var DotsFormTabs = children && React.Children.toArray(children).map(function (child, i) {
    var onSubmitAction = function onSubmitAction(e) {
      e.preventDefault();
      child.props.onSubmit();
      !child.props.blockNext && activeTab < tabs && onChangingTab(activeTab + 1);
    };

    var newChild = _extends({}, child, {
      props: _extends({}, tabsStyle, {
        blockNext: true
      }, child.props, {
        animation: animation,
        activeTab: i === activeTab,
        onSubmit: onSubmitAction
      })
    });

    return newChild;
  });
  var tabs = DotsFormTabs.length - 1;
  var ActiveTab = DotsFormTabs.find(function (tab) {
    return tab.props.activeTab;
  });

  var isBlocked = function isBlocked(index) {
    return index === activeTab || (index > 0 ? DotsFormTabs[index - 1].props.blockNext : DotsFormTabs[index].props.blockNext);
  };

  var changeTab = function changeTab(index) {
    return !isBlocked(index) && onChangingTab(index);
  };

  return /*#__PURE__*/React.createElement(DotsFormHolder, {
    topDots: topDots,
    styledComponents: styledComponents
  }, !removeDots && /*#__PURE__*/React.createElement(DotsHolder, {
    styledComponents: dotsStyledComponents
  }, DotsFormTabs.map(function (dot, index) {
    return /*#__PURE__*/React.createElement(DotForm, {
      key: index + 'Tab',
      active: index === activeTab,
      onClick: function onClick() {
        return changeTab(index);
      },
      activeStyledComponents: dotsActiveStyledComponents,
      dotsStyle: dotsStyle,
      disabled: isBlocked(index)
    });
  })), removeArrows ? ActiveTab : /*#__PURE__*/React.createElement(TabsHolder, null, /*#__PURE__*/React.createElement(ArrowButton, {
    onClick: function onClick() {
      return changeTab(activeTab - 1);
    },
    disabled: activeTab === 0 || isBlocked(activeTab - 1),
    styledComponents: arrowsStyledComponents,
    arrowsStyle: arrowsStyle
  }, '<'), ActiveTab, /*#__PURE__*/React.createElement(ArrowButton, {
    onClick: function onClick() {
      return changeTab(activeTab + 1);
    },
    disabled: activeTab === tabs || isBlocked(activeTab + 1),
    styledComponents: arrowsStyledComponents,
    arrowsStyle: arrowsStyle
  }, '>')));
};

function _templateObject$1() {
  var data = _taggedTemplateLiteralLoose(["\n    padding: 15px 20px;\n    text-align: center;\n    font: 18px inherit;\n    letter-spacing: 1px;\n    outline: none;\n    margin: 15px auto;\n\n    &[type='email'],\n    &[type='text'] {\n      width: 300px;\n      color: ", ";\n      border: 1px solid\n        ", ";\n      transition: all 0.4s;\n\n      &:focus {\n        border-color: ", ";\n      }\n\n      @media only screen and (max-width: 700px) {\n        width: 200px;\n      }\n    }\n\n    &[type='submit'] {\n      color: ", ";\n      background: ", ";\n      border: 1px solid ", ";\n      transition: all 0.4s;\n\n      &:hover {\n        cursor: pointer;\n        background: ", ";\n        border-color: ", ";\n      }\n\n      &:disabled {\n        cursor: default;\n        background: ", ";\n        border-color: ", ";\n      }\n    }\n\n    @media only screen and (max-width: 700px) {\n      display: flex;\n    }\n\n    ", ";\n  "]);

  _templateObject$1 = function _templateObject() {
    return data;
  };

  return data;
}
var StyledFormInput = styled.input(function (_ref) {
  var styledComponents = _ref.styledComponents,
      textEmailStyle = _ref.textEmailStyle,
      submitStyle = _ref.submitStyle;
  return css(_templateObject$1(), textEmailStyle && textEmailStyle.textColor || '#4e85af', textEmailStyle && textEmailStyle.borderColor || '#bcdef7', textEmailStyle && textEmailStyle.focusColor || '#4e85af', submitStyle && submitStyle.color || '#ffffff', submitStyle && submitStyle.background || '#68beff', submitStyle && submitStyle.background || '#68beff', submitStyle && submitStyle.hoverBackground || '#4e85af', submitStyle && submitStyle.hoverBackground || '#4e85af', submitStyle && submitStyle.disabledBackground || '#bcdef7', submitStyle && submitStyle.disabledBackground || '#bcdef7', styledComponents);
});

var Input = function Input(props) {
  return /*#__PURE__*/React.createElement(StyledFormInput, props);
};
var TabForm = function TabForm(props) {
  return /*#__PURE__*/React.createElement(DotsFormTab, props);
};
var Form = function Form(props) {
  return /*#__PURE__*/React.createElement(DotsForm, props);
};

export { Form, Input, TabForm };
//# sourceMappingURL=index.modern.js.map
